function [out] = integral_ekde(in, stddev_uncertainty,single)
    if (nargin < 3)
        single = 0;
    end
    if(size(stddev_uncertainty,1) == 1),
        stddev_uncertainty = repmat(stddev_uncertainty,getDim(in),1);
    end
    assert(size(stddev_uncertainty,1) == getDim(in));
% Kwak --------------------------------------------------------------------
%     stddev = getBW(in);
%     stddev = stddev(:,1);
%     stddev_new = stddev.*stddev_uncertainty./sqrt(stddev.^2 + stddev_uncertainty.^2);

    stddev = getBW(in);             % std's for kernels at each points
    stddev_new = sqrt(stddev .^ 2 + repmat((stddev_uncertainty .^ 2), 1, getNpts(in)));
                                    % convolution
    pts = getPoints(in);
    weights = getWeights(in);
    out = kde(pts, stddev_new, weights);
% Kwak --------------------------------------------------------------------    
    verify_kde(out, single);
end